﻿using System.Diagnostics;

namespace ImageConvertService.Biz.Models;

[DebuggerDisplay("P: {PathAndName}   W: {LastWrite}" )]
public class ArchiveEntry
{
    public string PathAndName { get; set; }
    public ArchiveEntryFileTimeTuple? FileTimeTuple { get; set; } = new();

    public DateTimeOffset? LastWrite { get => FileTimeTuple?.LastWrite; set => (FileTimeTuple ??= new()).LastWrite = value; }
    public DateTimeOffset? CreateTime { get => FileTimeTuple?.CreateTime; set => (FileTimeTuple ??= new()).CreateTime = value; }
    public DateTimeOffset? LastAccess { get => FileTimeTuple?.LastAccess; set => (FileTimeTuple ??= new()).LastAccess = value; }

    public byte[]? Content { get; set; }
}